<template>
    <v-row justify="center">
        <v-dialog max-width="600px" scrollable v-model="dialog">
            <template v-slot:activator="{ on, attrs }">
                <v-btn color="#fdb947" rounded class="mr-4" v-bind="attrs" v-on="on">
                    <v-icon>mdi-pencil</v-icon>
                    Editar horario
                </v-btn>
            </template>
            <v-card>
                <v-app-bar class="headline grey lighten-2">
                    <v-app-bar-nav-icon color="black" @click="dialog = false">
                        <v-icon>mdi-arrow-left</v-icon>
                    </v-app-bar-nav-icon>
                    <v-spacer></v-spacer>

                    <v-card-title class="text-center justify-center">Horario</v-card-title>
                    <v-spacer></v-spacer>

                    <v-btn color="black" icon @click="dialog = false">
                        <v-icon>mdi-close</v-icon>
                    </v-btn>
                </v-app-bar>

                <v-card-text>
                    <v-container>
                        <v-row>
                            <v-col v-for="(schedule, dayOfWeek) in delivery.schedule" :key="dayOfWeek">
                                <v-col cols="12" md="12" align="center">
                                    <v-btn class="titleName" :color="schedule.open ? '#fbc02d' : '#DDE3F3'">
                                        <v-icon class="pe-4 "> mdi-clock</v-icon>
                                        {{ dayOfWeek }}
                                    </v-btn>
                                </v-col>
                                <v-col cols="12" md="12" align="center"
                                    >{{ formatDateTo12(schedule.initHour) }}-{{ formatDateTo12(schedule.endHour) }}
                                </v-col>
                                <v-col cols="12" md="12" align="center">
                                    <ScheduledaysDialog :dia="dayOfWeek"> </ScheduledaysDialog>
                                </v-col>
                            </v-col>
                        </v-row>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="#fdb947" text @click="dialog = false">Cancelar</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>
<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import ScheduledaysDialog from '@/components/delivery/ScheduledaysDialog.vue';
import { Menu as ModelMenu } from '@/model/menu/Menu';
import { namespace } from 'vuex-class';
import { DeliveryMenu as ModelDeliveries } from '@/model/delivery/DeliveryMenu';

const menuStore = namespace('MenuModule');
const deliveryStore = namespace('DeliveryModule');

@Component({
    components: { ScheduledaysDialog }
})
export default class TimeSchedule extends Vue {
    @menuStore.State
    menu!: ModelMenu;

    @deliveryStore.State
    delivery!: ModelDeliveries;

    dialog = false;

    formatDateTo12(date: Date) {
        const time = new Date(date);
        let hours = time.getHours();
        const minutes: number = time.getMinutes();
        let midday = ' AM';

        // convertir a formato de 12 horas
        if (hours > 12) {
            hours = hours - 12;
            midday = ' PM';
        } else if (hours === 0) {
            hours = 12;
        }
        return (hours < 10 ? '0' + hours : hours) + ':' + (minutes < 10 ? '0' + minutes : minutes) + midday;
    }
}
</script>

<style type="text/css"></style>
<style type="text/css">
.titleName {
    border-radius: 20px;
    font-size: 15px;
    padding: 10px;
    font-weight: normal;
}
</style>
